/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	SG
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.util;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

/**
 *	SG<br>
 *
 *	SCORMSG.xmlのカプセルクラス<br>
 *
 */
public class SG {
	/** "SCORMSG.xml"のDOM Document */
	private static Document doc;

	/** "SCORMSG.xml"のルートノード */
	private static CachedNode SG;

	/**
	 * デフォルトコンストラクタ
	 */
	private SG() {}

	/**
	 *	初期化処理。SGファイルを展開する。 <br>
	 */
	private static void initialize() throws IOException, ParserConfigurationException, SAXException {
		synchronized (SG.class) {
			if (doc == null) {
				doc = XMLUtil.newDocumentBuilder(false).parse(SG.class.getResource("/conf/scorm/SCORMSG.xml").toString());
				SG = new CachedNode(doc.getDocumentElement());
			}
		}
	}

	/**
	 *	SG値を取得する<br>
	 *
	 *	@param	key キー名
	 *	@return	取得できたキー値
	 */
	public static String get(String key) throws IOException, ParserConfigurationException, SAXException {
		initialize();

		CachedNode node = SG.selectSimpleSingleNode(key);

		if (node == null) {
			return null;
		}

		String value = null;

		short nodeType = node.getNode().getNodeType();

		if (nodeType == Node.ELEMENT_NODE) {
			CachedNode textNode = node.selectSingleChildNode("text()");

			if (textNode != null) {
				value = textNode.getNodeValue();
			}
		}
		else {
			value = node.getNodeValue();
		}

		return value;
	}

	/**
	 *	SG値を複数取得する。<br>
	 *
	 *	@param	key 	キー名
	 *	@return	取得できたキー値
	 */
	public static String[] gets(String key) throws IOException, ParserConfigurationException, SAXException {
		initialize();

		CachedNode[] nodeList = SG.selectSimpleNodeList(key);

		if (nodeList == null) {
			return null;
		}

		String[] values = new String[nodeList.length];

		for (int i = 0; i < values.length; i++) {
			String value = null;

			short nodeType = nodeList[i].getNode().getNodeType();

			if (nodeType == Node.ELEMENT_NODE) {
				CachedNode textNode = nodeList[i].selectSingleChildNode("text()");

				if (textNode != null) {
					value = textNode.getNodeValue();
				}
			}
			else {
				value = nodeList[i].getNodeValue();
			}

			values[i] = value;
		}

		return values;
	}
}
